        LIST    p=16F628 ; PIC16F628 is the target processor

    	#include "P16F628.INC" ; Include header file

    cblock 0x20   ; Temporary storage
       time1
       time2
    endc

    __CONFIG _CP_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _LVP_OFF & _DATA_CP_OFF & _BODEN_OFF 
        org   0

        goto    start

;********************************************************************
;               Serial Routines
;********************************************************************
serialinit bsf STATUS, RP0
	bcf TXSTA, SYNC		;Asynchronous Mode
	bcf TXSTA, BRGH		;Low Clock Speed
	movlw 0x33		;Data Rate(don't just type 51 -it won't work)
	movwf SPBRG
	bcf TXSTA,TX9	;Eight bit send
	bsf TXSTA,TXEN	;enable sending
	bcf STATUS, RP0
	bsf RCSTA,SPEN ;Enable Serial Port
	bsf RCSTA,CREN ;Enable Continuous Receive
	bcf RCSTA,RX9 ;Eight Bit receive
	return
send movwf TXREG
	bsf STATUS,RP0
	btfss TXSTA,TRMT
	goto $-1
	bcf STATUS,RP0
	return
recv btfss PIR1, RCIF
	 goto $-1
	 movf RCREG,w
	 bcf PIR1,RCIF
	 btfss RCSTA,OERR
	 return
	 bcf RCSTA,CREN
	 bsf RCSTA,CREN
	 retlw '?'
;********************************************************************
;               MAIN CODE
;********************************************************************

delay   decfsz time1,f
    goto delay
    decfsz time2,f
    goto delay
    decf time1,f    ;because they will carry over to 0
    decf time2,f
    return

light	bsf PORTA,0
	call delay
	bcf PORTA,0
	return

init bsf STATUS, RP0
	bcf TRISA,0
	bcf STATUS, RP0
	return

start call init
	bsf PORTA,0
	call delay
	bcf PORTA,0
	call delay
	bsf PORTA,0
	call delay
	bcf PORTA,0
	call serialinit
	movlw 'E'
	call send
	movlw 'C'
	call send
	movlw 'H'
	call send
	movlw 'O'
	call send
	movlw ' '
	call send
loop	call recv
	call send
	call light
	goto loop
	end
