;error1: got rlf opcode wrong
;error2: forgot to set tristate bits for output
;error3: needed delays


        LIST    p=16F84 ; PIC16F84 is the target processor

	#include "P16F84.INC" ; Include header file
	#define E 0	;pick any port A pins (0-4)
	#define RS 2

	cblock 0x20   ; Temporary storage
	   outbyte
	   time1
	   time2
	endc

	__CONFIG _CP_OFF & _WDT_OFF & _XT_OSC & _PWRTE_ON 
        org   0

        goto    start

;********************************************************************
;               Routines 
;********************************************************************
;sends high 4 bits of variable 'char' to lcd
nybout	movlw b'11110000'	;high nybble bitmask
	andwf outbyte,w		;set top nybble
	iorwf PORTB,f		;high bits set, now low bits must be set
	movlw b'00001111'	;high nybble bitmask
	iorwf outbyte,w		;set top nybble
	andwf PORTB,f		;low bits set
	bsf PORTA,E
	call qdelay			;this is necessary, even for a 4MHz clock
	bcf PORTA,E			;clock it
	retlw 1

;send a character/command in w to lcd
lcdcmd	bcf PORTA,RS		;RS low for commands
	goto skiprs		;doing it this way allows the pin to be used for something else
lcdchar bsf PORTA,RS		;RS high for characters
skiprs	movwf outbyte
	call nybout
	rlf outbyte,f		
	rlf outbyte,f		;put low nybble in high position to facilitate output
	rlf outbyte,f
	rlf outbyte,f
	call nybout
	retlw 1			;the character/command has been sent

lcdinit	bsf STATUS, RP0
	movlw b'00001111'
	andwf TRISB,f			;RB4-7 outputs
	bcf TRISA,E			;enable line output
	bcf TRISA,RS		;rs line output
	bcf STATUS, RP0
	bcf PORTA,RS		;command mode
	movlw b'00110000'	;8bit mode
	movwf outbyte
	call nybout
	call qdelay
	call nybout
	call nybout
	bcf outbyte,4		;4bit mode
	call nybout
	movlw b'00101000'	;2 lines
	call lcdcmd
	movlw b'00001100'	;disp on,cursor off,blink off
	call lcdcmd
	movlw b'00000110'	;increasing cursor,no shift
	call lcdcmd
	movlw b'00000001'	;clear screen- needs delay because it takes 165 clock cycles
	call lcdcmd	
	call delay	
	retlw 1

delay 	decfsz time1,f
	goto delay
	decfsz time2,f
	goto delay
	decf time1,f	;because they will carry over to 0
	decf time2,f
	return
	
qdelay	decfsz time1,f
	goto qdelay
	decf time1,f
	return

;********************************************************************
;               Main
;********************************************************************
start   call delay
	call lcdinit
	;call delay		;DEBUG
	movlw 'C'
	call lcdchar
	movlw 'h'
	call lcdchar
	movlw 'r'
	call lcdchar
	movlw 'i'
	call lcdchar
	movlw 's'
	call lcdchar
	movlw ' '
	call lcdchar
	movlw 'C'
	call lcdchar
	movlw 'l'
	call lcdchar
	movlw 'a'
	call lcdchar
	movlw 'r'
	call lcdchar
	movlw 'k'
	call lcdchar
	call delay
	call delay
	call delay
scroll	movlw 0x1C		;shift display left
	call delay
	call lcdcmd
	goto scroll
	END







